<?php
/*
Plugin Name: Статистика сайта по счетчику LiveInternet.ru
Plugin URI: http://aireo.ru
Description: Отображает статистику сайта по данным счетчика LiveInternet.ru
Version: 0.1
Author: Илья
Author URI: http://aireo.ru
*/

/*  Copyright 2013  Илья (email: mail@aireo.ru)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
class getlicounterparams
{
	// Русское название параметров
	protected static $arrayNames = array
	(
		'LI_site' => 'Адрес сайта',
		'LI_month_hit' => 'Просмотров за месяц',
		'LI_month_vis' => 'Уникальных пользователей за месяц',
		'LI_week_hit' => 'Просмотров за неделю',
		'LI_week_vis' => 'Уникальных пользователей за месяц',
		'LI_day_hit' => 'Просмотров за сутки',
		'LI_day_vis' => 'Уникальных пользователей за сутки',
		'LI_today_hit' => 'Просмотров за сегодня',
		'LI_today_vis' => 'Уникальных пользователей за сегодня',
		'LI_online_hit' => 'Смотрят сейчас',
		'LI_online_vis' => 'Пользователей сейчас на сайте',
	);

	// Статус наличия ошибки, из-за чего нельзя выполнять код дальше
	protected static $error = false;

	public static function getLI()
	{
		$siteAddress = self::getSiteAddress();
		$counterParams = file_get_contents('http://counter.yadro.ru/values?site='.$siteAddress);
		
		if (!$counterParams) self::error('Счетчик для данного сайта не зарегистрирован в LI');
		
		$paramsArray = self::getArrayFromString($counterParams);
		
		if (!$paramsArray) 
		{
			self::error('Ошибка получения параметров счетчика LI');
		}

		if ("'".$siteAddress."'" != $paramsArray['LI_site']) self::error('Адрес сайта не совпадает с адресом в счетчике LI ('.$siteAddress.', '.$paramsArray['LI_site'].')');
		
		self::printParams($paramsArray);
	}	
	
	protected static function getSiteAddress($http=false)
	{
		if (self::$error) return false;
		
		$ret = preg_replace('/^www\./u', '', $_SERVER['SERVER_NAME']);
		
		if ($http) 
		{
			$ret = 'http://'.$ret;
		}
		
		return $ret;
	}
	
	protected static function getArrayFromString($string)
	{
		if (self::$error) return false;
		
		$_counterParamsArray = explode("\n", $string);
		
		foreach ($_counterParamsArray as $item)
		{
			unset ($_tmp);
			
			$_tmp = explode('=', $item);
			
			if (count($_tmp) == 2)
			{
				$ret[trim($_tmp[0])] = preg_replace('/;$/u', '', trim($_tmp[1]));
			}
		}
		
		return $ret;
	}
	
	protected static function error($message=false)
	{
		echo 'Error: '.$message;
		self::$error = true;
	}	
	
	protected static function printParams($arr)
	{
		if (self::$error) return false;
		
		foreach (array_keys($arr) as $key)
		{
			switch ($key)
			{
				case 'LI_today_hit' :
					echo '<div><b>'.self::$arrayNames[$key].': '.$arr[$key].'</b></div>';
				break;
				case 'LI_today_vis' :
					echo '<div><b>'.self::$arrayNames[$key].': '.$arr[$key].'</b></div>';
				break;
				case 'LI_site' :
					echo '<div style="margin: 0 0 10px; font-size: 1.1em; font-family: Tahoma; font-weight: bold;">'.self::$arrayNames[$key].': '.$arr[$key].'</div>';
				break;
				default :
					echo '<div>'.self::$arrayNames[$key].': '.$arr[$key].'</div>';
			}
		}
		
		// подсчитываем сколько просмотров на 1 посетителя в среднем за данные сутки
			$usersUniqueToday = $arr['LI_today_vis'];
			$viewsToday = $arr['LI_today_hit'];
			
			if ($usersUniqueToday > 0 && $viewsToday > 0)
			{
				$viewsOnOne = number_format($viewsToday / $usersUniqueToday, 2, ',', ' ');
			} else
				{
					$viewsOnOne = 0;
				}
			echo '<div style="margin-top: 5px; padding-top: 3px; border-top: 1px solid #D4D4D4;"><b>Просмотров на посетителя за сутки: '.$viewsOnOne.'</b></div>';
	}


}


// getcounterparams::getLI();

function getlicounterparams_dashboard_widget_function() {
	// Display whatever it is you want to show
	getlicounterparams::getLI();
} 

// Create the function use in the action hook
function getlicounterparams_add_dashboard_widgets() {
	wp_add_dashboard_widget('getlicounterparams_dashboard_widget', 'Статистика сайта по LiveInternet', 'getlicounterparams_dashboard_widget_function');
}
// Hoook into the 'wp_dashboard_setup' action to register our other functions
add_action('wp_dashboard_setup', 'getlicounterparams_add_dashboard_widgets' );